appId: 'github.com/vladimiry/ElectronMail'
artifactName: ${name}-${version}-${os}-${arch}${env.ARTIFACT_NAME_POSTFIX}.${ext}
productName: 'ElectronMail'

forceCodeSigning: false

# TODO consider moving fully bundable 'dependencies' to 'devDependencies' to reduce final package size

directories:
  output: ./dist
files:
  # TODO exclude not needed stuff in 'files:' section to reduce app packages size, can save megabytes, so a significant improvement
  - './app/**/*'
  - './package.json'
  - '!app/electron-preload/browser-window-e2e.js'
  - '!node_modules/rxjs/{_esm5,_esm2015,src,bundles}'
  - '!node_modules/pureimage/{firstimages,tests}'
  # sodium-native TODO: include into the package only needed prebuilds for the platform is being built
  - '!node_modules/sodium-native/{src,test,libsodium,tmp}'
  - '!node_modules/sodium-native/prebuilds/linux-arm'
  - '!node_modules/sodium-native/prebuilds/win32-ia32'
  # remeda
  - '!node_modules/remeda/{coverage,scripts,src}'
  # spellchecker
  - '!node_modules/spellchecker/{spec}'
compression: normal
asar: true
asarUnpack:
  - '**/node_modules/sodium-native/**/*'
  - '**/node_modules/keytar/**/*'
  - '**/node_modules/spellchecker/**/*'
  - '**/node_modules/desktop-idle/**/*'
afterPack: './scripts/electron-builder/hooks/afterPack/index.js'

mac:
  icon: ./app/assets/icons/mac/icon.icns
  category: public.app-category.productivity
  darkModeSupport: true
  target:
    - {target: dmg}

dmg:
  icon: ./app/assets/icons/mac/icon.icns
  iconSize: 128
  contents:
    - {x: 380, y: 240, type: link, path: /Applications}
    - {x: 122, y: 240, type: file}

linux:
  icon: ./app/assets/icons/png
  category: Office
  packageCategory: Office
  desktop:
    StartupWMClass: electron-mail
  executableArgs:
    - '--js-flags="--max-old-space-size=6144"'

snap:
  confinement: strict
  stagePackages:
    - default
  plugs:
    - default
    - password-manager-service
  environment:
    DISABLE_WAYLAND: 1
    HUNSPELL_DICTIONARIES: $SNAP/usr/share/hunspell

win:
  artifactName: ${name}-${version}-windows-${arch}.${ext}
  icon: ./app/assets/icons/win/icon.ico
  target:
    - {target: nsis}

nsis:
  artifactName: ${name}-${version}-windows-${arch}-nsis-installer.${ext}
  oneClick: false
  perMachine: false
  include: scripts/electron-builder/installer.nsh
